<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_ListaPrecioDetalleLog.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Mantenimiento de los registros de la tabla MST_ListaPrecioDetalleLog */
abstract class BaseMST_ListaPrecioDetalleLogDP extends MST_ListaPrecioDetalleLogBV
{
    /* Constructor ( Establece los valores desde un objeto MST_ListaPrecioDetalleLogBN ) */
    public function __construct( MST_ListaPrecioDetalleLogBN $o_MST_ListaPrecioDetalleLogBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN ) )
        {
            $this->setByBN( $o_MST_ListaPrecioDetalleLogBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_ListaPrecioDetalleLogBN */
    public function setByBN( MST_ListaPrecioDetalleLogBN $o_MST_ListaPrecioDetalleLogBN )
    {
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getIdLPDLog() ) )
        {
            $this->setIdLPDLog( $o_MST_ListaPrecioDetalleLogBN->getIdLPDLog() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_ListaPrecioDetalleLogBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_ListaPrecioDetalleLogBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getIdItem() ) )
        {
            $this->setIdItem( $o_MST_ListaPrecioDetalleLogBN->getIdItem() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getIdTipoPrecio() ) )
        {
            $this->setIdTipoPrecio( $o_MST_ListaPrecioDetalleLogBN->getIdTipoPrecio() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getFechaInicio() ) )
        {
            $this->setFechaInicio( $o_MST_ListaPrecioDetalleLogBN->getFechaInicio() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getFechaFin() ) )
        {
            $this->setFechaFin( $o_MST_ListaPrecioDetalleLogBN->getFechaFin() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_ListaPrecioDetalleLogBN->getEstado() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getPrecioCosto() ) )
        {
            $this->setPrecioCosto( $o_MST_ListaPrecioDetalleLogBN->getPrecioCosto() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getPorcentajeUtilidad() ) )
        {
            $this->setPorcentajeUtilidad( $o_MST_ListaPrecioDetalleLogBN->getPorcentajeUtilidad() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getPrecioVenta() ) )
        {
            $this->setPrecioVenta( $o_MST_ListaPrecioDetalleLogBN->getPrecioVenta() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getMontoDescuento() ) )
        {
            $this->setMontoDescuento( $o_MST_ListaPrecioDetalleLogBN->getMontoDescuento() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getPorcentajeDescuento() ) )
        {
            $this->setPorcentajeDescuento( $o_MST_ListaPrecioDetalleLogBN->getPorcentajeDescuento() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getDescuentoFlag() ) )
        {
            $this->setDescuentoFlag( $o_MST_ListaPrecioDetalleLogBN->getDescuentoFlag() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_ListaPrecioDetalleLogBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_ListaPrecioDetalleLogBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_ListaPrecioDetalleLogBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getFechaLog() ) )
        {
            $this->setFechaLog( $o_MST_ListaPrecioDetalleLogBN->getFechaLog() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getUsuarioLog() ) )
        {
            $this->setUsuarioLog( $o_MST_ListaPrecioDetalleLogBN->getUsuarioLog() );
        }
        if ( !is_null( $o_MST_ListaPrecioDetalleLogBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_ListaPrecioDetalleLogBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_ListaPrecioDetalleLogFN = new MST_ListaPrecioDetalleLogFN();
        $o_MST_ListaPrecioDetalleLogBN = $o_MST_ListaPrecioDetalleLogFN->selectByPk( $this->getIdLPDLog() );
        if ( is_null( $o_MST_ListaPrecioDetalleLogBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_ListaPrecioDetalleLog ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdLPDLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdLPDLog";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdLPDLog()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoPrecio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoPrecio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoPrecio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaInicio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFin() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaFin";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaFin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioCosto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioCosto";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioCosto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPorcentajeUtilidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PorcentajeUtilidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getPorcentajeUtilidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioVenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioVenta";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioVenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoDescuento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoDescuento";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoDescuento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPorcentajeDescuento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PorcentajeDescuento";
                $s_SQLQuery2 .= $s_Separator."".$this->getPorcentajeDescuento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescuentoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescuentoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescuentoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaLog";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaLog()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioLog";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioLog()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_ListaPrecioDetalleLog SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoPrecio() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoPrecio = '".$this->getIdTipoPrecio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicio() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaInicio = '".$this->getFechaInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFin() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaFin = '".$this->getFechaFin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioCosto() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioCosto = ".$this->getPrecioCosto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPorcentajeUtilidad() ) )
            {
                $s_SQLQuery .= $s_Separator."PorcentajeUtilidad = ".$this->getPorcentajeUtilidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioVenta() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioVenta = ".$this->getPrecioVenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoDescuento() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoDescuento = ".$this->getMontoDescuento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPorcentajeDescuento() ) )
            {
                $s_SQLQuery .= $s_Separator."PorcentajeDescuento = ".$this->getPorcentajeDescuento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescuentoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."DescuentoFlag = '".$this->getDescuentoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaLog() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaLog = '".$this->getFechaLog()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioLog() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioLog = '".$this->getUsuarioLog()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdLPDLog = ".$this->getIdLPDLog().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_ListaPrecioDetalleLog WHERE  IdLPDLog = ".$this->getIdLPDLog().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>